package linearalgebra;

public interface VectorInterface extends Cloneable {
	public Object clone();
	public int getDimension();
	public void swapDimensions( int index1, int index2 );
	public double getValue(int index);
	public double getLengthSquared();
	public double getLength();
	public double getInnerProduct(VectorInterface v);
	public double getCosBetween(VectorInterface v);
	public double getRadiansBetween(VectorInterface v);
	public boolean isLinearlyIndependent(VectorInterface v);
	public boolean isOrthogonal(VectorInterface v);
	public boolean isZero();
	public boolean normalize();
}