package linearalgebra.graph;

import java.awt.*;
import java.awt.geom.*;

public class GraphPanel extends javax.swing.JPanel {
	/**
	 * 
	 */
	private static final long	serialVersionUID	= 5695269252363350389L;
	private GraphObject[] lines;
	private double llx; 
	private double lly; 
	private double urx; 
	private double ury;
	
	public GraphPanel(GraphObject[] lines, double llx, double lly, double urx, double ury ) {
		this.llx = llx; 
		this.lly = lly; 
		this.urx = urx; 
		this.ury = ury;
		this.lines = lines;
		setBackground(Color.white);
			setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		setSize(20,40);
	}
	
	BasicStroke stroke = new BasicStroke( 0 );
	
	public void paint( Graphics g ) {
		super.paint(g);				
		Dimension d = getSize();
		if( g instanceof Graphics2D ) {
			Graphics2D g2 = (Graphics2D)g;
			g2.setStroke(stroke);
			g2.scale(d.width/(urx-llx), d.height/(lly-ury));
			g2.translate(-llx, -ury);
//			g2.scale(d.width/30.0, -d.height/30.0);
//			g2.translate(15, -15);
			drawAxis(g2);
			for( int i = 0; i < lines.length; i++ ) {
				lines[i].paint(g2);
			}

			g2.scale((urx-llx)/d.width, (lly-ury)/d.height);
			g2.translate(llx, ury);
//			g2.translate(-15, 15);
//			g2.scale(30.0/d.width, -30.0/d.width);
					
		}
	}
	
	private void drawAxis( Graphics2D g ) {
		Dimension d = getSize();
		g.setColor(Color.gray);
		g.drawLine(0, -d.height, 0, d.height);
		g.drawLine(-d.width, 0, d.width, 0);
		for( int i = -25; i < 25; i++ ) {
			g.draw(new Line2D.Double(-.5,   i, .5,  i ));
			g.draw(new Line2D.Double(  i, -.5,  i, .5 ));
		}
	}
	//{{DECLARE_CONTROLS
	//}}
}
