package linearalgebra.graph;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.Line2D;

import linearalgebra.numeric.NumericVectorInterface;

public class GraphVector extends GraphObject {
	private NumericVectorInterface v;
	private NumericVectorInterface o;
	Color c;
	Line2D line = null;
	Shape arrow = null;
	
	public GraphVector( NumericVectorInterface v, NumericVectorInterface offset, Color c ) {
		this.v = (NumericVectorInterface)v.clone();
		this.o = (NumericVectorInterface)offset.clone();
		this.c = c;
	}
	
    public void paint(Graphics2D g) {
		if( line == null ) {
			v.linearCombinationEquals(o, 1.0);
			line = new Line2D.Double(o.getValue(0), o.getValue(1), v.getValue(0), v.getValue(1));
//			arrow = new Ellipse2D.Double(x, y, 1, 1);
		}
		g.setColor(c);
		g.draw(line);
//		g.draw(arrow);
    }

}